searchNodes=[{"doc":"Utility module for handling various sources of configuration using Kuddle.","ref":"Kuddle.Config.html","title":"Kuddle.Config","type":"module"},{"doc":"Load a config map from a given kdl blob. Usage: { :ok , config } = Kuddle.Config . load_config_blob ( &quot;&quot;&quot; my_application { key &quot;value&quot; key2 subkey=&quot;subvalue&quot; } &quot;&quot;&quot; )","ref":"Kuddle.Config.html#load_config_blob/2","title":"Kuddle.Config.load_config_blob/2","type":"function"},{"doc":"Load config from a directory, the extensions of the config files must be supplied as well. Usage: { :ok , config } = Kuddle.Config . load_config_directory ( &quot;/path/to/kdl/config/directory&quot; , [ &quot;.kdl&quot; , &quot;.kuddle&quot; ] )","ref":"Kuddle.Config.html#load_config_directory/3","title":"Kuddle.Config.load_config_directory/3","type":"function"},{"doc":"Load config from a given kuddle document. Usage: = Kuddle.Config . load_config_document ( document )","ref":"Kuddle.Config.html#load_config_document/2","title":"Kuddle.Config.load_config_document/2","type":"function"},{"doc":"Load a KDL config file Usage: { :ok , config } = Kuddle.Config . load_config_file ( &quot;/path/to/kdl/config/file&quot; )","ref":"Kuddle.Config.html#load_config_file/2","title":"Kuddle.Config.load_config_file/2","type":"function"},{"doc":"Use Kuddle as a config provider for a directory, if you want to load a single file see Kuddle.Config.Provider instead Example defp releases do [ application : [ config_providers : [ { Kuddle.Config.Provider , [ paths : [ { :system , &quot;PATH_TO_CONFIG&quot; , &quot;/default/path/to/kdl/config&quot; } ] , extensions : [ &quot;.kdl&quot; , &quot;.kuddle&quot; ] ] } ] ] ] end","ref":"Kuddle.Config.DirectoryProvider.html","title":"Kuddle.Config.DirectoryProvider","type":"module"},{"doc":"Specify a list of extensions that should be treated as kdl files. Default: [&quot;.kdl&quot;] Example: [ extensions : [ &quot;.kdl&quot; , &quot;.kuddle&quot; ] ]","ref":"Kuddle.Config.DirectoryProvider.html#t:extensions_option/0","title":"Kuddle.Config.DirectoryProvider.extensions_option/0","type":"type"},{"doc":"","ref":"Kuddle.Config.DirectoryProvider.html#t:option/0","title":"Kuddle.Config.DirectoryProvider.option/0","type":"type"},{"doc":"Options supported by the DirectoryProvider Example: [ paths : [ &quot;/etc/my_application/config&quot; ] , extensions : [ &quot;.cfg.kdl&quot; , &quot;.cfg.kuddle&quot; ] ]","ref":"Kuddle.Config.DirectoryProvider.html#t:options/0","title":"Kuddle.Config.DirectoryProvider.options/0","type":"type"},{"doc":"The directory provider allows specifying multiple paths to get config files from, this path will be joined with the wildcard */ and postfixed with the extensions. Example: [ paths : [ &quot;/etc/my_application/config&quot; ] ]","ref":"Kuddle.Config.DirectoryProvider.html#t:paths_option/0","title":"Kuddle.Config.DirectoryProvider.paths_option/0","type":"type"},{"doc":"Use Kuddle as a config provider for a directory, if you want to load a single file see Kuddle.Config.Provider instead Example release :default do set config_providers : [ { Kuddle.Config.Provider , [ paths : [ { :system , &quot;PATH_TO_CONFIG&quot; , &quot;/default/path/to/kdl/config&quot; } ] , extensions : [ &quot;.kdl&quot; , &quot;.kuddle&quot; ] ] } ] end","ref":"Kuddle.Config.Distillery.DirectoryProvider.html","title":"Kuddle.Config.Distillery.DirectoryProvider","type":"module"},{"doc":"","ref":"Kuddle.Config.Distillery.DirectoryProvider.html#init/1","title":"Kuddle.Config.Distillery.DirectoryProvider.init/1","type":"function"},{"doc":"Use Kuddle as a config provider for a single file, if you want to load a directory see Kuddle.Config.Distillery.DirectoryProvider instead. This is a variant of the Config.Provider specifically used for Distillery Example release :default do set config_providers : [ { Kuddle.Config.Provider , [ path : { :system , &quot;PATH_TO_CONFIG&quot; , &quot;/default/path/to/kdl/config&quot; } ] } ] end","ref":"Kuddle.Config.Distillery.Provider.html","title":"Kuddle.Config.Distillery.Provider","type":"module"},{"doc":"","ref":"Kuddle.Config.Distillery.Provider.html#init/1","title":"Kuddle.Config.Distillery.Provider.init/1","type":"function"},{"doc":"Use Kuddle as a config provider for a single file, if you want to load a directory see Kuddle.Config.DirectoryProvider instead Example defp releases do [ application : [ config_providers : [ { Kuddle.Config.Provider , [ path : { :system , &quot;PATH_TO_CONFIG&quot; , &quot;/default/path/to/kdl/config&quot; } ] } ] ] ] end","ref":"Kuddle.Config.Provider.html","title":"Kuddle.Config.Provider","type":"module"},{"doc":"","ref":"Kuddle.Config.Provider.html#t:option/0","title":"Kuddle.Config.Provider.option/0","type":"type"},{"doc":"","ref":"Kuddle.Config.Provider.html#t:options/0","title":"Kuddle.Config.Provider.options/0","type":"type"},{"doc":"The path to the KDL config file that should be loaded.","ref":"Kuddle.Config.Provider.html#t:path_option/0","title":"Kuddle.Config.Provider.path_option/0","type":"type"},{"doc":"Annotation cast types. User specific types can be registered by setting the kuddle_config types: Example config :kuddle_config , types : [ typename : { Module , cast_function_name } , geopoint : { MyGeoPoint , :cast } , ] The cast function must return {:ok, any()} or :error if it cannot cast the given value. Kuddle Config has some default types they can be overwritten by setting the default_types: config :kuddle_config , default_types : [ date : { Date , :from_iso8601 } , utc_datetime : { Kuddle.Config.Types.DateTime , :cast } , naive_datetime : { NaiveDateTime , :from_iso8601 } , time : { Time , :from_iso8601 } , decimal : { Kuddle.Config.Types.Decimal , :cast } , atom : { Kuddle.Config.Types.Atom , :cast } , boolean : { Kuddle.Config.Types.Boolean , :cast } , tuple : { Kuddle.Config.Types.Tuple , :cast } , list : { Kuddle.Config.Types.List , :cast } , ] The purpose of the default_types is to provide some sane default which doesn't require any additional configuration from you, the user. However they can be disabled by setting the default_types config.","ref":"Kuddle.Config.Types.html","title":"Kuddle.Config.Types","type":"module"},{"doc":"Cast given value to a different type, normally the input will a string.","ref":"Kuddle.Config.Types.html#cast/2","title":"Kuddle.Config.Types.cast/2","type":"function"},{"doc":"","ref":"Kuddle.Config.Types.html#internal_cast/2","title":"Kuddle.Config.Types.internal_cast/2","type":"function"},{"doc":"","ref":"Kuddle.Config.Types.Atom.html","title":"Kuddle.Config.Types.Atom","type":"module"},{"doc":"","ref":"Kuddle.Config.Types.Atom.html#cast/1","title":"Kuddle.Config.Types.Atom.cast/1","type":"function"},{"doc":"","ref":"Kuddle.Config.Types.Boolean.html","title":"Kuddle.Config.Types.Boolean","type":"module"},{"doc":"","ref":"Kuddle.Config.Types.Boolean.html#cast/1","title":"Kuddle.Config.Types.Boolean.cast/1","type":"function"},{"doc":"","ref":"Kuddle.Config.Types.DateTime.html","title":"Kuddle.Config.Types.DateTime","type":"module"},{"doc":"","ref":"Kuddle.Config.Types.DateTime.html#cast/1","title":"Kuddle.Config.Types.DateTime.cast/1","type":"function"},{"doc":"","ref":"Kuddle.Config.Types.Decimal.html","title":"Kuddle.Config.Types.Decimal","type":"module"},{"doc":"","ref":"Kuddle.Config.Types.Decimal.html#cast/1","title":"Kuddle.Config.Types.Decimal.cast/1","type":"function"},{"doc":"","ref":"Kuddle.Config.Types.List.html","title":"Kuddle.Config.Types.List","type":"module"},{"doc":"","ref":"Kuddle.Config.Types.List.html#cast/1","title":"Kuddle.Config.Types.List.cast/1","type":"function"},{"doc":"","ref":"Kuddle.Config.Types.Tuple.html","title":"Kuddle.Config.Types.Tuple","type":"module"},{"doc":"","ref":"Kuddle.Config.Types.Tuple.html#cast/1","title":"Kuddle.Config.Types.Tuple.cast/1","type":"function"},{"doc":"","ref":"Kuddle.Config.Utils.html","title":"Kuddle.Config.Utils","type":"module"},{"doc":"","ref":"Kuddle.Config.Utils.html#apply_configuration/1","title":"Kuddle.Config.Utils.apply_configuration/1","type":"function"},{"doc":"","ref":"Kuddle.Config.Utils.html#deep_merge/2","title":"Kuddle.Config.Utils.deep_merge/2","type":"function"},{"doc":"","ref":"Kuddle.Config.Utils.html#deep_merge/3","title":"Kuddle.Config.Utils.deep_merge/3","type":"function"},{"doc":"","ref":"Kuddle.Config.Utils.html#mod_to_atom/1","title":"Kuddle.Config.Utils.mod_to_atom/1","type":"function"},{"doc":"","ref":"Kuddle.Config.Utils.html#mod_to_existing_atom/1","title":"Kuddle.Config.Utils.mod_to_existing_atom/1","type":"function"},{"doc":"","ref":"Kuddle.Config.Utils.html#resolve_root_path!/1","title":"Kuddle.Config.Utils.resolve_root_path!/1","type":"function"},{"doc":"","ref":"Kuddle.ConfigError.html","title":"Kuddle.ConfigError","type":"exception"}]